<?php
/**
 * DeleteAllApi
 * PHP version 5
 *
 * @category Class
 * @package  Boxxai
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * boxx client
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Boxxai\Core\Api;

use \Boxxai\Core\ApiClient;
use \Boxxai\Core\ApiException;
use \Boxxai\Configuration;
use \Boxxai\ObjectSerializer;

/**
 * DeleteAllApi Class Doc Comment
 *
 * @category Class
 * @package  Boxxai
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class DeleteAllApi
{
    /**
     * API Client
     *
     * @var \Boxxai\Core\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \Boxxai\Core\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\Boxxai\Core\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \Boxxai\Core\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \Boxxai\Core\ApiClient $apiClient set the API client
     *
     * @return DeleteAllApi
     */
    public function setApiClient(\Boxxai\Core\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation apiDataAlldeleteDelete
     *
     * Delete all documents
     *
     * @param \Boxxai\Core\Model\DeleteAll $request_data request data (required)
     * @throws \Boxxai\Core\ApiException on non-2xx response
     * @return \Boxxai\Core\Model\InlineResponse2001
     */
    public function apiDataAlldeleteDelete($request_data)
    {
        list($response) = $this->apiDataAlldeleteDeleteWithHttpInfo($request_data);
        return $response;
    }

    /**
     * Operation apiDataAlldeleteDeleteWithHttpInfo
     *
     * Delete all documents
     *
     * @param \Boxxai\Core\Model\DeleteAll $request_data request data (required)
     * @throws \Boxxai\Core\ApiException on non-2xx response
     * @return array of \Boxxai\Core\Model\InlineResponse2001, HTTP status code, HTTP response headers (array of strings)
     */
    public function apiDataAlldeleteDeleteWithHttpInfo($request_data)
    {
        // verify the required parameter 'request_data' is set
        if ($request_data === null) {
            throw new \InvalidArgumentException('Missing the required parameter $request_data when calling apiDataAlldeleteDelete');
        }
        // parse inputs
        $resourcePath = "/api/data/alldelete/";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        // body params
        $_tempBody = null;
        if (isset($request_data)) {
            $_tempBody = $request_data;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'DELETE',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Boxxai\Core\Model\InlineResponse2001',
                '/api/data/alldelete/'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Boxxai\Core\Model\InlineResponse2001', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxxai\Core\Model\InlineResponse2001', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxxai\Core\Model\InlineResponse4001', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 401:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxxai\Core\Model\InlineResponse4001', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 405:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxxai\Core\Model\InlineResponse4001', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
